/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * scanCheck.java
 *
 * Created on 27/05/2011, 08:38:53
 */

package exemplo;

import br.com.tecpoint.api.DeviceParameters;
import br.com.tecpoint.api.Devices;
import br.com.tecpoint.api.LogFont;
import br.com.tecpoint.api.VAPIInterface;
import br.com.tecpoint.api.impl.Utils;
import br.com.tecpoint.api.impl.VisionAPIImpl;
import br.com.tecpoint.api.win32.W32API.HWND;
import br.com.tecpoint.api.win32.W32API.LPARAM;
import br.com.tecpoint.api.win32.W32API.WPARAM;
import com.sun.jna.Native;
import com.sun.media.jai.codec.ByteArraySeekableStream;
import java.awt.Window;
import java.awt.image.renderable.ParameterBlock;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import javax.swing.ImageIcon;
import javax.swing.JFrame;

/**
 *
 * @author Cirilo Veloso - http://www.cjv.com.br
 */
public class ScanCheque extends javax.swing.JFrame {

    HWND hwnd = new HWND();
    Window w;
    WindowsProcedure wndproc;
    int docId = 0;
    DeviceParameters devParam = new DeviceParameters();
    VisionAPIImpl visionAPI = new VisionAPIImpl(true); //debugMode = true
    int deviceEngine = 0;
    int errCode;
    int statusCode;
    int readerOn = 0;
    int pocket = 1;
    boolean saveImages = false;
    //MICR CMC7 fields
    String cmc7;
    String banco;
    String agencia;
    String compe;
    String C1;
    String conta;
    String C2;
    String cheque;
    String C3;
    LogFont logFont = new LogFont("Tahoma", 700);
    String textoPrint = "";
    String imagePrint = ".\\images\\Example.bmp\u0000";
    //String imagePrint = "C:\\Users\\Cirilo\\Documents\\NetBeansProjects\\TesteTecpointVisionAPI\\images\\Stamp.bmp\u0000";
    File file =new File(imagePrint);
    int posHorizontal = 30;
    private JFrame config;


    /** Creates new form scanCheck */
    public ScanCheque() {
        initComponents();
        initParameters();
        enableButtons(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        btnLigar = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        btnDesligar = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        btnOnline = new javax.swing.JButton();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        btnCapturar = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        btnFreeTrack = new javax.swing.JButton();
        jSeparator8 = new javax.swing.JToolBar.Separator();
        btnVersao = new javax.swing.JButton();
        jSeparator5 = new javax.swing.JToolBar.Separator();
        btnIDCard = new javax.swing.JButton();
        jSeparator6 = new javax.swing.JToolBar.Separator();
        btnStatus = new javax.swing.JButton();
        jSeparator9 = new javax.swing.JToolBar.Separator();
        btnConfig = new javax.swing.JButton();
        jSeparator7 = new javax.swing.JToolBar.Separator();
        btnSair = new javax.swing.JButton();
        pnlTabs = new javax.swing.JTabbedPane();
        pnlCheques = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        pnlFront = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        imgFront = new javax.swing.JLabel();
        pnlRear = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        imgRear = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jLog = new javax.swing.JTextArea();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Exemplo Utilização TecpointVisionAPI");

        jToolBar1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jToolBar1.setRollover(true);

        btnLigar.setMnemonic('N');
        btnLigar.setText("ON");
        btnLigar.setToolTipText("CheckReader Turn On");
        btnLigar.setFocusable(false);
        btnLigar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnLigar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnLigar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLigarActionPerformed(evt);
            }
        });
        jToolBar1.add(btnLigar);
        jToolBar1.add(jSeparator1);

        btnDesligar.setMnemonic('F');
        btnDesligar.setText("OFF");
        btnDesligar.setToolTipText("CheckReader Turn Off");
        btnDesligar.setFocusable(false);
        btnDesligar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnDesligar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnDesligar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDesligarActionPerformed(evt);
            }
        });
        jToolBar1.add(btnDesligar);
        jToolBar1.add(jSeparator2);

        btnOnline.setMnemonic('O');
        btnOnline.setText("OnLine");
        btnOnline.setToolTipText("Starts OnLine or ChangeParameters");
        btnOnline.setFocusable(false);
        btnOnline.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnOnline.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnOnline.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOnlineActionPerformed(evt);
            }
        });
        jToolBar1.add(btnOnline);
        jToolBar1.add(jSeparator4);

        btnCapturar.setMnemonic('S');
        btnCapturar.setText("Start Feeding");
        btnCapturar.setToolTipText("Start or Stop Feeding");
        btnCapturar.setFocusable(false);
        btnCapturar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnCapturar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnCapturar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCapturarActionPerformed(evt);
            }
        });
        jToolBar1.add(btnCapturar);
        jToolBar1.add(jSeparator3);

        btnFreeTrack.setMnemonic('V');
        btnFreeTrack.setText("FreeTrack");
        btnFreeTrack.setToolTipText("Some information about CheckReader");
        btnFreeTrack.setFocusable(false);
        btnFreeTrack.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnFreeTrack.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnFreeTrack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFreeTrackActionPerformed(evt);
            }
        });
        jToolBar1.add(btnFreeTrack);
        jToolBar1.add(jSeparator8);

        btnVersao.setMnemonic('V');
        btnVersao.setText("API Version");
        btnVersao.setToolTipText("Some information about CheckReader");
        btnVersao.setFocusable(false);
        btnVersao.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnVersao.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnVersao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnVersaoActionPerformed(evt);
            }
        });
        jToolBar1.add(btnVersao);
        jToolBar1.add(jSeparator5);

        btnIDCard.setMnemonic('V');
        btnIDCard.setText("IDCard");
        btnIDCard.setToolTipText("Some information about CheckReader");
        btnIDCard.setFocusable(false);
        btnIDCard.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnIDCard.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnIDCard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnIDCardActionPerformed(evt);
            }
        });
        jToolBar1.add(btnIDCard);
        jToolBar1.add(jSeparator6);

        btnStatus.setMnemonic('S');
        btnStatus.setText("Status");
        btnStatus.setToolTipText("CheckReader Status");
        btnStatus.setFocusable(false);
        btnStatus.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnStatus.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnStatus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStatusActionPerformed(evt);
            }
        });
        jToolBar1.add(btnStatus);
        jToolBar1.add(jSeparator9);

        btnConfig.setMnemonic('C');
        btnConfig.setText("Config");
        btnConfig.setToolTipText("Set Device Parameters");
        btnConfig.setFocusable(false);
        btnConfig.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnConfig.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnConfig.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConfigActionPerformed(evt);
            }
        });
        jToolBar1.add(btnConfig);
        jToolBar1.add(jSeparator7);

        btnSair.setMnemonic('E');
        btnSair.setText("EXIT");
        btnSair.setToolTipText("Exit Program");
        btnSair.setFocusable(false);
        btnSair.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnSair.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSairActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSair);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "Compe", "Banco", "Agência", "C1", "N° Conta", "C2", "Nº do Cheque", "C3", "Valor"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.setEditingColumn(0);
        jTable1.setEditingRow(0);
        jScrollPane2.setViewportView(jTable1);

        javax.swing.GroupLayout pnlChequesLayout = new javax.swing.GroupLayout(pnlCheques);
        pnlCheques.setLayout(pnlChequesLayout);
        pnlChequesLayout.setHorizontalGroup(
            pnlChequesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 701, Short.MAX_VALUE)
        );
        pnlChequesLayout.setVerticalGroup(
            pnlChequesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlChequesLayout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 346, Short.MAX_VALUE)
                .addContainerGap())
        );

        pnlTabs.addTab("Cheques", pnlCheques);

        imgFront.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jScrollPane3.setViewportView(imgFront);

        javax.swing.GroupLayout pnlFrontLayout = new javax.swing.GroupLayout(pnlFront);
        pnlFront.setLayout(pnlFrontLayout);
        pnlFrontLayout.setHorizontalGroup(
            pnlFrontLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 701, Short.MAX_VALUE)
        );
        pnlFrontLayout.setVerticalGroup(
            pnlFrontLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 357, Short.MAX_VALUE)
        );

        pnlTabs.addTab("Image Front", pnlFront);

        imgRear.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jScrollPane4.setViewportView(imgRear);

        javax.swing.GroupLayout pnlRearLayout = new javax.swing.GroupLayout(pnlRear);
        pnlRear.setLayout(pnlRearLayout);
        pnlRearLayout.setHorizontalGroup(
            pnlRearLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 701, Short.MAX_VALUE)
        );
        pnlRearLayout.setVerticalGroup(
            pnlRearLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 357, Short.MAX_VALUE)
        );

        pnlTabs.addTab("Image Rear", pnlRear);

        jLog.setColumns(20);
        jLog.setFont(new java.awt.Font("Verdana", 0, 10));
        jLog.setForeground(java.awt.Color.red);
        jLog.setRows(5);
        jScrollPane1.setViewportView(jLog);

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 536, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 29, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE)
            .addComponent(pnlTabs, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE)
            .addComponent(statusPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(pnlTabs, javax.swing.GroupLayout.PREFERRED_SIZE, 385, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnLigarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLigarActionPerformed
        // TODO add your handling code here:
        w = new Window(this);
        w.setVisible(true);
        hwnd.setPointer(Native.getWindowPointer(w));
        wndproc = new WindowsProcedure(hwnd, visionAPI, devParam, this);
        //
        int vApiSetDeviceEngine = visionAPI.setDeviceEngine(deviceEngine);
        System.out.println(deviceEngine+" "+vApiSetDeviceEngine);
        if (vApiSetDeviceEngine == 0) {
            readerOn = visionAPI.startUp(hwnd);
            if (readerOn > 0) {
                statusMessageLabel.setText("Try to on checkReader - " + hwnd + " - deviceID = " + VisionAPIImpl.deviceID);

                boolean online = visionAPI.onLine();
                if (online) {
                    enableButtons(true);
                } else {
                    enableButtons(false);
                }
            } else {
                reportApiError();
            }
        }
}//GEN-LAST:event_btnLigarActionPerformed

    private void btnDesligarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDesligarActionPerformed
        // TODO add your handling code here:
        if (readerOn > 0) {
            if (visionAPI.shutDown()) {
                readerOn = 0;
                enableButtons(false);
                statusMessageLabel.setText("OFF (desligado)!");
            }
        }
}//GEN-LAST:event_btnDesligarActionPerformed

    private void btnOnlineActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOnlineActionPerformed
        // TODO add your handling code here:
        statusCode = visionAPI.getDeviceState();
        if (statusCode == VisionAPIImpl.DeviceOnLine) {
            visionAPI.changeParameters();
        } else {
            visionAPI.onLine();
        }
        this.statusMessageLabel.setText(deviceStatus());
}//GEN-LAST:event_btnOnlineActionPerformed

    private void btnCapturarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCapturarActionPerformed
        // TODO add your handling code here:
        if (VisionAPIImpl.deviceID > 0) {
            statusCode = visionAPI.getDeviceState();
            if (statusCode == VisionAPIImpl.DeviceOnLine) {
                if (devParam.bPrintEnable == VisionAPIImpl.TRUE) {
                    doPrint();
                }
                if (visionAPI.startFeeding()) {
                    this.jLog.append("Ready to read DOCs \n");
                }
            } else {
                if (visionAPI.stopFeeding()) {
                    this.jLog.append("Stop read.\n");
                }
            }
        }
        this.statusMessageLabel.setText(deviceStatus());
        //this.jLog.append(deviceStatus());
}//GEN-LAST:event_btnCapturarActionPerformed

    private void btnFreeTrackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFreeTrackActionPerformed
        // TODO add your handling code here:
        visionAPI.freeTrack(pocket);
}//GEN-LAST:event_btnFreeTrackActionPerformed

    private void btnVersaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnVersaoActionPerformed
        // TODO add your handling code here:
        //String versao1 = api.vApiGetVersion();
        //String versao2 = api.getApiRelease();
        //String versao3 = api.getDriverRelease();
        //statusMessageLabel.setText(versao1+" \n"+versao2+" \n"+versao3);
        if (VisionAPIImpl.deviceID > 0) {
            jLog.append(visionAPI.getVersion() + "\n");
            jLog.append(visionAPI.getApiRelease() + "\n");
            jLog.append(visionAPI.getFwVersion() + "\n");
            jLog.append(visionAPI.getDriverRelease() + "\n");
            int[] feature = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_MICR_CMC7);
            jLog.append("CMC7 enable = " + Utils.intToBool(feature[0]) + "\n");
            jLog.append("Número de Série: " + visionAPI.getSerialNumber() + "\n");
            //jLog.append(deviceFeature());
            jLog.append("Configuração atual: \n");
            jLog.append(currentDeviceParameters());
        }
}//GEN-LAST:event_btnVersaoActionPerformed

    private void btnIDCardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnIDCardActionPerformed
        // TODO add your handling code here:
        if (visionAPI.changeParameters()) {
            int[] pLen = {340};
            Devices[] devices = {new Devices()};
            jLog.append("IDCARD INFO\n"+visionAPI.getIDCardDescription(pLen, devices)+"\n");
            statusMessageLabel.setText("CheckReader "  + visionAPI.getDeviceStateString());
        }
}//GEN-LAST:event_btnIDCardActionPerformed

    private void btnStatusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStatusActionPerformed
        // TODO add your handling code here:
        if (VisionAPIImpl.deviceID > 0) {
            statusMessageLabel.setText("Cod." + visionAPI.getDeviceState() + " - " + visionAPI.getDeviceStateString() + " error: " + visionAPI.getError() + " - " + visionAPI.getErrorString());
        }
}//GEN-LAST:event_btnStatusActionPerformed

    private void btnConfigActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConfigActionPerformed
        // TODO add your handling code here:
        if (config == null) {
            config = new Config(this, true);
            config.setLocationRelativeTo(this);
        }
        config.setVisible(true);
    }//GEN-LAST:event_btnConfigActionPerformed

    private void btnSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSairActionPerformed
        // TODO add your handling code here:
        boolean shutDown = true;
        if (readerOn > 0) {
            shutDown = visionAPI.shutDown();
        }
        if (shutDown) {
            readerOn = 0;
            visionAPI.destroy();
            this.dispose();
        } else {
            statusMessageLabel.setText("CheckReader's not turned off yet !");
        }
}//GEN-LAST:event_btnSairActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ScanCheque().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCapturar;
    private javax.swing.JButton btnConfig;
    private javax.swing.JButton btnDesligar;
    private javax.swing.JButton btnFreeTrack;
    private javax.swing.JButton btnIDCard;
    private javax.swing.JButton btnLigar;
    private javax.swing.JButton btnOnline;
    private javax.swing.JButton btnSair;
    private javax.swing.JButton btnStatus;
    private javax.swing.JButton btnVersao;
    private javax.swing.JLabel imgFront;
    private javax.swing.JLabel imgRear;
    private javax.swing.JTextArea jLog;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator5;
    private javax.swing.JToolBar.Separator jSeparator6;
    private javax.swing.JToolBar.Separator jSeparator7;
    private javax.swing.JToolBar.Separator jSeparator8;
    private javax.swing.JToolBar.Separator jSeparator9;
    private javax.swing.JTable jTable1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JPanel pnlCheques;
    private javax.swing.JPanel pnlFront;
    private javax.swing.JPanel pnlRear;
    private javax.swing.JTabbedPane pnlTabs;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables


    public boolean isSaveImages() {
        return saveImages;
    }

    public void setSaveImages(boolean saveImages) {
        this.saveImages = saveImages;
    }

    private void enableButtons(boolean enable) {
        btnLigar.setEnabled(!enable);
        btnDesligar.setEnabled(enable);
        btnOnline.setEnabled(enable);
        btnCapturar.setEnabled(enable);
        btnFreeTrack.setEnabled(enable);
        btnVersao.setEnabled(enable);
        btnIDCard.setEnabled(enable);
        btnStatus.setEnabled(enable);
        btnConfig.setEnabled(!enable);
        btnSair.setEnabled(!enable);
    }

    private String deviceStatus() {
        if (VisionAPIImpl.deviceID > 0) {
            return "CheckReader " + visionAPI.getDeviceStateString() + "\n";
        } else {
            return "Check Reader Turn Off!\n";
        }
    }

    public void changedStatus() {
        this.jLog.append(deviceStatus());
    }

    private void initParameters() {
        devParam.bMICREnable = VAPIInterface.TRUE;
        devParam.bMICRSaveSamples = VAPIInterface.FALSE;
        devParam.bOneDoc = VAPIInterface.TRUE;
        devParam.bPrintEnable = VAPIInterface.PRINTER_DISABLE; //VAPIInterface.PRINTER_ENABLE_LEADING_EDGE | VAPIInterface.PRINTER_AGP_QUALITY_NORMAL;
        //
        devParam.cRejectSymbol = '?';
        devParam.nFeedingMode = VAPIInterface.DROP_FEED;
        devParam.nMICRFont = VAPIInterface.MICR_FONT_AUTO;
        devParam.nMICRSpaces = VAPIInterface.SPACES_NONE;

        devParam.ImagePropertiesFront1.Format = VAPIInterface.FORMAT_JPEG;
        devParam.ImagePropertiesFront1.ColorDepth = 16;
        devParam.ImagePropertiesFront1.Resolution = 100;
        devParam.ImagePropertiesFront1.Threshold = 75;
        devParam.ImagePropertiesFront1.Paging = VAPIInterface.PAGING_ONLY_SINGLE;

        devParam.ImagePropertiesFront2.Format = VAPIInterface.FORMAT_NONE;
        devParam.ImagePropertiesFront2.ColorDepth = 256;
        devParam.ImagePropertiesFront2.Resolution = 100;
        devParam.ImagePropertiesFront2.Threshold = 75;
        devParam.ImagePropertiesFront2.Paging = VAPIInterface.PAGING_ONLY_SINGLE;

        devParam.ImagePropertiesRear1.Format = VAPIInterface.FORMAT_JPEG;
        devParam.ImagePropertiesRear1.ColorDepth = 16;
        devParam.ImagePropertiesRear1.Resolution = 100;
        devParam.ImagePropertiesRear1.Threshold = 75;
        devParam.ImagePropertiesRear1.Paging = VAPIInterface.PAGING_ONLY_SINGLE;

        devParam.ImagePropertiesRear2.Format = VAPIInterface.FORMAT_NONE;
        devParam.ImagePropertiesRear2.ColorDepth = 256;
        devParam.ImagePropertiesRear2.Resolution = 100;
        devParam.ImagePropertiesRear2.Threshold = 75;
        devParam.ImagePropertiesRear2.Paging = VAPIInterface.PAGING_ONLY_SINGLE;

        devParam.SnippetProperties0.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties1.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties2.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties3.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties4.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties5.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties6.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties7.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties8.Enable = VAPIInterface.FALSE;
        devParam.SnippetProperties9.Enable = VAPIInterface.FALSE;
    }

    public String deviceFeature() {
        StringBuffer sb = new StringBuffer("======================================\n");
        int intResult[];
        String strResult;
        //Tipo de Leitor
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_DEVICE_TYPE);
        sb.append("Modelo de Leitor: " + Utils.deviceTypeString(intResult[0]) + "\n");
        strResult = (String) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_SN);
        sb.append("Número de Série: " + strResult + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_MICR_AUTO);
        sb.append("MICR auto: " + Utils.intToBool(intResult[0]) + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_MICR_CMC7);
        sb.append("MICR CMC7: " + Utils.intToBool(intResult[0]) + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_MICR_OCR_CMC7);
        sb.append("MICR OCR+CMC7: " + Utils.intToBool(intResult[0]) + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_IMAGE_FRONT);
        sb.append("IMAGE FRONT: " + Utils.intToBool(intResult[0]) + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_IMAGE_FRONT_DPI);
        sb.append("IMAGE FRONT DPI: " + intResult[0] + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_IMAGE_REAR);
        sb.append("IMAGE REAR: " + Utils.intToBool(intResult[0]) + "\n");
        intResult = (int[]) visionAPI.getDeviceFeature(VisionAPIImpl.DEVICE_FEATURE_IMAGE_REAR_DPI);
        sb.append("IMAGE REAR DPI: " + intResult[0] + "\n");

        sb.append("======================================\n");
        return sb.toString();
    }

    public String currentDeviceParameters() {
        StringBuffer sb = new StringBuffer("======================================\n");
        sb.append("MICR Enable: " + devParam.bMICREnable + "\n");
        sb.append("MICR Font: " + devParam.nMICRFont + "\n");
        sb.append("MICR SaveSamples: " + devParam.bMICRSaveSamples + "\n");
        sb.append("MICR Spaces: " + devParam.nMICRSpaces + "\n");
        sb.append("Reject Symbol: " + devParam.cRejectSymbol + "\n");
        sb.append("LOGFONT\n");
        sb.append("Face: " + new String(logFont.lfFaceName) + "\n");
        sb.append("Weight:" + logFont.lfWeight + "\n");
        sb.append("Quality:" + logFont.lfQuality + "\n");
        sb.append("PitchAndFamily: " + logFont.lfPitchAndFamily + "\n");
        sb.append("Image Front 1: " + "\n");
        sb.append("...Format: " + devParam.ImagePropertiesFront1.Format + "\n");
        sb.append("...Resolution: " + devParam.ImagePropertiesFront1.Resolution + "\n");
        sb.append("...ColorDepth: " + devParam.ImagePropertiesFront1.ColorDepth + "\n");
        sb.append("...Threshold: " + devParam.ImagePropertiesFront1.Threshold + "\n");
        sb.append("...Paging: " + devParam.ImagePropertiesFront1.Paging + "\n");

        sb.append("Image Front 2: " + "\n");
        sb.append("...Format: " + devParam.ImagePropertiesFront2.Format + "\n");
        sb.append("...Resolution: " + devParam.ImagePropertiesFront2.Resolution + "\n");
        sb.append("...ColorDepth: " + devParam.ImagePropertiesFront2.ColorDepth + "\n");
        sb.append("...Threshold: " + devParam.ImagePropertiesFront2.Threshold + "\n");
        sb.append("...Paging: " + devParam.ImagePropertiesFront2.Paging + "\n");

        sb.append("Image Rear 1: " + "\n");
        sb.append("...Format: " + devParam.ImagePropertiesRear1.Format + "\n");
        sb.append("...Resolution: " + devParam.ImagePropertiesRear1.Resolution + "\n");
        sb.append("...ColorDepth: " + devParam.ImagePropertiesRear1.ColorDepth + "\n");
        sb.append("...Threshold: " + devParam.ImagePropertiesRear1.Threshold + "\n");
        sb.append("...Paging: " + devParam.ImagePropertiesRear1.Paging + "\n");

        sb.append("Image Rear 2: " + "\n");
        sb.append("...Format: " + devParam.ImagePropertiesRear2.Format + "\n");
        sb.append("...Resolution: " + devParam.ImagePropertiesRear2.Resolution + "\n");
        sb.append("...ColorDepth: " + devParam.ImagePropertiesRear2.ColorDepth + "\n");
        sb.append("...Threshold: " + devParam.ImagePropertiesRear2.Threshold + "\n");
        sb.append("...Paging: " + devParam.ImagePropertiesRear2.Paging + "\n");
        //
        sb.append("Print Enable: " + devParam.bPrintEnable + "\n");
        sb.append("One Doc: " + devParam.bOneDoc + "\n");
        sb.append("Feeding Mode: " + devParam.nFeedingMode + "\n");
        sb.append("======================================\n");
        return sb.toString();
    }

    public void reportApiError() {
        errCode = visionAPI.getApiError();
        if (errCode == VisionAPIImpl.API_ERR_USB) {
            // An USB ERROR has Occurred
            this.jLog.append(errCode + " - USB ERROR\n");
            // Ask Information About USB Error
            this.jLog.append(visionAPI.getUsbErrorString() + "\n");
        } else if (errCode == VisionAPIImpl.API_ERR_DEVICE) {
            reportDeviceError();
        } else {
            this.jLog.append("API error Code = " + errCode + " - " + visionAPI.getApiErrorString() + "\n");
        }
    }

    public void reportDeviceError() {
        errCode = visionAPI.getDeviceError();
        if (errCode == VisionAPIImpl.API_ERR_USB) {
            // USB ERROR
            this.jLog.append(errCode + " - USB ERROR\n");
            this.jLog.append(visionAPI.getUsbErrorString() + "\n");
        } else {
            // It is a Device Error
            this.jLog.append(visionAPI.getDeviceErrorString());
            if (errCode == VisionAPIImpl.DEVICE_ERR_SORTER_ERROR_PENDING) {
                // Jam or PhotoCell Calibration Error
                this.jLog.append(errCode + " - " + visionAPI.getSorterErrorString() + "\n");
            }
        }
    }

    public void eventSorterConnected() {
        this.jLog.append("CheckReader Connected!\n");
        boolean boolOk = false;
        if (visionAPI.changeParameters()) {
            enableButtons(false);
            try {
                //initParameters();
                //this.jLog.append(currentDeviceParameters());
                boolOk = visionAPI.setDeviceParametersHelp2(devParam);
                if (boolOk) {
                    this.jLog.append("CheckReader was SET !\n");
                    boolean onLine = visionAPI.onLine();
                    if (onLine) {
                        enableButtons(true);
                    }
                } else {
                    this.jLog.append("Parameters NOT SET ! \n");
                    reportApiError();
                    enableButtons(true);
                }
            } catch (Exception e) {
                this.jLog.append("Configuração inicial não realizada" + "\n");
                reportApiError();
                e.printStackTrace();
            }
        }
        this.statusMessageLabel.setText(deviceStatus());
        this.jLog.append(deviceStatus());
    }

    public void eventSorterDisconnected() {
        this.jLog.append("CheckRead Disconnected!\n");
        VisionAPIImpl.deviceID = 0;
        this.statusMessageLabel.setText(deviceStatus());
    }

    public void eventNewDocument(int docId) {
        if(this.deviceEngine==VisionAPIImpl.DEVICE_IDEAL){
          this.jLog.append("New Document -> Doc Id = " + docId + "   Tipo = " + Utils.getDocumentTypeString(visionAPI.getDocumentType(docId)) + "\n");
        }
        if (devParam.bPrintEnable == VisionAPIImpl.TRUE) {
            doPrint();
        }       
    }

    public void eventMicroAvailable(int docId) {
        cmc7 = visionAPI.getMicrCodeline();
        if (cmc7.length() >= 33) {
            banco = cmc7.substring(1, 4);
            agencia = cmc7.substring(4, 8);
            compe = cmc7.substring(10, 13);
            C1 = "0";
            cheque = cmc7.substring(14, 20);
            C2 = "0";
            conta = cmc7.substring(23, 33);
            C3 = "0";
            jTable1.setValueAt(compe, docId, 0);
            jTable1.setValueAt(banco, docId, 1);
            jTable1.setValueAt(agencia, docId, 2);
            jTable1.setValueAt(C1, docId, 3);
            jTable1.setValueAt(conta, docId, 4);
            jTable1.setValueAt(C2, docId, 5);
            jTable1.setValueAt(cheque, docId, 6);
            jTable1.setValueAt(C3, docId, 7);
            jTable1.setValueAt("100,00", docId, 8);
        }
        this.jLog.append("DocId= " + docId + " CMC7 = " + cmc7 + "\n");

    }

    public void eventSetItemOutPut(int docId) {
        if (visionAPI.setPocket(docId, pocket)) {
            this.jLog.append("DocId= " + docId + " Pocket = " + pocket + "\n");
        }
    }

    public void eventInsidePocket(int docId) {
        this.jLog.append("DocId= " + docId + " Inside de Pocket \n");
    }

    public void eventSorterException(HWND hWnd, int uMsg, WPARAM wParam, LPARAM lParam) {
        switch (lParam.intValue()) {
            case 29: {
                this.jLog.append("CheckReader doen´t connect on computer - error " + lParam.intValue() + " \n");
                if (visionAPI.shutDown()) {
                    readerOn = 0;
                    VisionAPIImpl.deviceID = 0;
                    this.statusMessageLabel.setText(deviceStatus());
                    this.jLog.append(deviceStatus());
                }
                break;
            }
            case 12: {
                this.jLog.append("Invalid parameters error = " + lParam.intValue() + " \n");
                if (visionAPI.shutDown()) {
                    readerOn = 0;
                    VisionAPIImpl.deviceID = 0;
                    this.statusMessageLabel.setText(deviceStatus());
                    this.jLog.append(deviceStatus());
                }
                break;
            }
            case 35: {
                this.jLog.append("Invalid Send Print Command = " + lParam.intValue() + " \n");
                break;
            }
            default: {
                this.jLog.append("Error Exception Number  - " + lParam.intValue() + "\n");
                break;
            }
        }
    }

    public void eventImageReady(int imageID, byte[] image, String jaiFileFormatName) {
        this.jLog.append("ImageID= " + imageID + " Image Ready \n");
        if (image != null) {
            ByteArraySeekableStream stream = null;
            try {
                stream = new ByteArraySeekableStream(image);
            } catch (IOException ex) {
                Logger.getLogger(this.getName()).log(Level.SEVERE, null, ex);
            }
            ParameterBlock pb = new ParameterBlock();
            pb.add(stream);
            //with JAI plugin is possible load TIFF file
            PlanarImage image1 = JAI.create(jaiFileFormatName, pb);

            if (imageID == 0) {
                imgFront.setIcon(new ImageIcon( image1.getAsBufferedImage()) );
                //pnlFront.setImage(image);
                pnlFront.repaint();
            }
            if (imageID == 2) {
                imgRear.setIcon(new ImageIcon(image1.getAsBufferedImage()) );
                //pnlRear.setImage(image);
                pnlRear.repaint();
            }
        }
    }

    public void eventDocCompleted(int docId) {
        this.jLog.append("DocId= " + docId + " Doc Completed ! \n");
    }

    public void eventMagCard() {
        this.jLog.append(" MAGCARD ! \n");
    }

    public void eventSetDownStreamOptions() {
        this.jLog.append(" SET DOWNSTREAM OPTIONS ! \n");
    }

    public void eventCompressedImgForDecision() {
        this.jLog.append(" Compressed IMAGE FOR DECISION ! \n");
    }

    private void doPrint() {
        if (new String(textoPrint).equals("\u0000")) {
            if (file.exists()) {
                System.out.println("Arquivo: " + imagePrint);
                visionAPI.sendPrinterData(0, logFont, null, 0, imagePrint.getBytes(), posHorizontal, VisionAPIImpl.PRT_SRC_FILE);
            } else {
                try {
                    System.out.println("Imagem para impressão não existe - " + file.getCanonicalPath());
                } catch (IOException ex) {
                    Logger.getLogger(ScanCheque.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        } else {
            visionAPI.sendPrinterData(0, logFont, textoPrint.getBytes(), posHorizontal, null, 0, VisionAPIImpl.PRT_SRC_FILE);
        }
    }

}
